
import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Boilerplate } from 'src/app/models/boilerplate.model';
import { BoilerplateService } from 'src/app/services/boilerplate.service';



@Component({
  selector: 'app-boilerplate-details',
  templateUrl: './boilerplate-details.component.html',
  styleUrls: ['./boilerplate-details.component.scss']
})
export class BoilerplateDetailsComponent implements OnInit {

  currentboilerplate: Boilerplate = {
    has_prefix: false,
    has_main: false,
    has_suffix: false
  };
  message = '';

  constructor(
    private boilerplateService: BoilerplateService,
    private route: ActivatedRoute,
    private router: Router) { }

  ngOnInit(): void {
    this.message = '';
    this.getBoilerplate(this.route.snapshot.params.gb, this.route.snapshot.params.id);
  }

  getBoilerplate(gb:any, id: number): void {
    this.boilerplateService.get(gb, id)
      .subscribe(
        data => {
          this.currentboilerplate = data;
          console.log(data);
        },
        error => {
          console.log(error);
        });
  }

  updateBoilerplate(): void {
    this.boilerplateService.update(this.route.snapshot.params.gb, this.currentboilerplate.id, this.currentboilerplate)
      .subscribe(
        response => {
          console.log(response);
          this.message = response.message;
          window.location.reload();
        },
        error => {
          console.log(error);
        });
  }

  deleteBoilerplate(): void {
    if(confirm("Αre you sure you want to delete this Boilerplate?")) {
      this.boilerplateService.delete(this.route.snapshot.params.gb, this.currentboilerplate.id)
        .subscribe(
          response => {
            console.log(response);
            this.router.navigate(['/groupboilerplates/'+ this.route.snapshot.params.gb +'/boilerplates']);
          },
          error => {
            console.log(error);
          });
      }
  }
}
