import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Main } from '../models/main.model';

const baseUrl = 'http://155.207.131.19:8000/api-auth/groupboilerplates/0/boilerplates/';
const Url = '/main/';

@Injectable({
  providedIn: 'root'
})
export class MainService {

  constructor(private http: HttpClient) { }

  getAll(boilerplate: any): Observable<Main[]> {
    return this.http.get<Main[]>(`${baseUrl}${boilerplate}${Url}`);
  }

  get(boilerplate: any, id: any): Observable<Main> {
    return this.http.get(`${baseUrl}${boilerplate}${Url}${id}`);
  }

  create(boilerplate: any, data: any): Observable<any> {
    return this.http.post(`${baseUrl}${boilerplate}${Url}`, data);
  }

  update(boilerplate: any, id: any, data: any): Observable<any> {
    return this.http.put(`${baseUrl}${boilerplate}${Url}${id}/`, data);
  }

  delete(boilerplate: any, id: any): Observable<any> {
    return this.http.delete(`${baseUrl}${boilerplate}${Url}${baseUrl}${id}`);
  }

  getsubject(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/subject/`);
  }

  getstateitem(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/stateitem/`);
  }

  getstatevalue(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/statevalue/`);
  }

  getshall(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/shall/`);
  }
  
  getverb(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/verb/`);
  }

  getquantifier(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/quantifier/`);
  }

  getnumunit(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/numunit/`);
  }

  getfifuintsysstatset(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/fifuintsysstatset/`);
  }

  getstsysconset(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/main/choices/stsysconset/`);
  }
 
}
